

CodeMirror.defineMode("spell-checker", function(config, parserConfig) {


	// Define what separates a word
	var rx_word = "\t!\"#$%&()*+,-./:“”„‘’»«;<=>?@[\\]^_—–`{|}~ ";


	function isSpellingError(word) {

		// handle single quotes at the beginning/end of the word ... pretty dirty hack
		if (word.startsWith("'") || word.endsWith("'")) {
			word = word.replace(/^'|'$/g, '');
		}

		// check if in custom dic
		if (ignoreList.indexOf(word.replace(/'s$/, '')) > -1) {
			return false;
		} 

		// check if all capitalized
		if (word.toUpperCase() == word) {
			return false;
		}

		// check if string has number
		if (/\d+/.test(word)) {
			return false;
		}

		// check if word is 1 letter only
		if (word.length <= 1) {
			return false;
		}

		// finaly check in typo
		if (typo && !typo.check(word)) {
			return true;
		}

		// finaly check in nspell
		// if (mySpell && !mySpell.correct(word)) {
		// 	return true;
		// }

		return false; // word is ok by default
	}



	// Create the overlay and such
	var overlay = {
		token: function(stream, state) {
			var ch = stream.peek();
			var word = "";

			if (rx_word.includes(ch)) {
				//if (/[\W']/.test(ch)) {
				stream.next();
				return null;
			}

			while ((ch = stream.peek()) != null && !rx_word.includes(ch)) {
			//while ((ch = stream.peek()) != null && !/[\W']/.test(ch)) {
				word += ch;
				stream.next();
			}

			if (isSpellingError(word)) {
				return "spell-error"; // CSS class: cm-spell-error
			}

			return null;
		}
	};

	var mode = CodeMirror.getMode(
		config, config.backdrop || "text/plain"
	);

	return CodeMirror.overlayMode(mode, overlay, true);
});